#include <windows.h>
#include <windowsx.h>
#include <stdlib.h>

#include "STR_PLUG.H"

// 
HINSTANCE plugin_hInst;

struct St_Reader_Plugin_Structure Plugin_Data_Struct;
struct St_Plugin_Submenu_Structure Plugin_Submenu_Struct_Array[2];	//2  St_Plugin_Submenu_Structure  

struct ini_data_struct {
  unsigned char example_edit_string [256];
  unsigned int example_radiobutton_state;
  unsigned int example_combobox_state;
  unsigned int example_checkbox_state;
};

struct ini_data_struct ini_data_structure;

unsigned char mttf_tag[] = "//mtff//";
char my_format_pattern[] = "*.mtff";
unsigned char st_plugin_converter_ini_data_string[] = "E\0RB\0CHB\0COMBS\0";
unsigned char st_plugin_converter_ini_data[256+1+3+1+5] = "";	//256   edit- ( ) +  1   radiobox'  combobox' + 3  (ON  OFF)  checkbox' + 5 
unsigned long st_plugin_converter_ini_data_long=&st_plugin_converter_ini_data;
char St_Reader_plugin_text[] = "St Reader converter";
unsigned int local_language_code = 0;				//             =0   
unsigned int *current_language_file_buffer_address = 0;
unsigned char *ini_data_string_address;

unsigned int end_text_position;			//  Plugin_goto_menu_dlg_proc
unsigned int middle_text_position;			//  Plugin_goto_menu_dlg_proc

char checkbox_on_code[] = "ON";
char checkbox_off_code[] = "OFF";

//+++++++++++++++++++++

BOOL WINAPI _stdcall DllEntryPoint(
  HMODULE hModule,
  DWORD   fdwReason,
  LPVOID  lpvReserved)

{
  switch(fdwReason)
  {
    case DLL_PROCESS_ATTACH:
    {
      plugin_hInst=hModule;
      break;
    }

    case DLL_PROCESS_DETACH:
    {
      break;
    }
  }
  return TRUE;
}

//+++++++++++++++++++++

unsigned int _export _stdcall St_Reader_Plugin_Entry(void)
/*    St_Reader_Plugin_Structure
:

:
  <>0 -    St_Reader_Plugin_Structure, 0 -    */

{

unsigned int (*Plugin_text_strings_address)(unsigned int, unsigned char *, unsigned int, unsigned char *, unsigned int) = Plugin_text_strings;
unsigned int (*St_Reader_Plugin_Options_address)(HWND, unsigned int) = St_Reader_Plugin_Options;
unsigned int (*St_Reader_Plugin_Convertor_Format_address)(unsigned char *, unsigned int, unsigned char *, HWND) = St_Reader_Plugin_Convertor_Format;
unsigned int (*St_Reader_Plugin_Convertor_address)(unsigned char *, unsigned int, unsigned int *, unsigned int *,unsigned int, unsigned char *, HWND) = St_Reader_Plugin_Convertor;
unsigned int (*PluginAboutMenuProc_address)(HWND) = PluginAboutMenuProc;
unsigned int (*PluginGotoMenuProc_address)(HWND) = PluginGotoMenuProc;


  Plugin_Data_Struct.st_plugin_size=sizeof Plugin_Data_Struct;	// 
  Plugin_Data_Struct.st_plugin_string=&St_Reader_plugin_text;		//  "St Reader converter"
  Plugin_Data_Struct.st_plugin_ver=10;		//  1.0
  Plugin_Data_Struct.st_plugin_options=1;	//     
  Plugin_Data_Struct.st_plugin_ini_data_string_address=&st_plugin_converter_ini_data_string;	//       INI-
  Plugin_Data_Struct.st_plugin_ini_data_address=&st_plugin_converter_ini_data;	//     INI-
  Plugin_Data_Struct.st_plugin_format_number=-2;		// My test format = -2,           (   str_plug.inc)
  Plugin_Data_Struct.st_plugin_converter_veracity=4;	//     - 4 ( 5)

  Plugin_Data_Struct.st_plugin_converter_unicode_flag=0;	//  ,    0
  Plugin_Data_Struct.st_plugin_converter_font_code=-1;		//  ,    -1
  Plugin_Data_Struct.st_plugin_converter_right_to_left_flag=0;	//  ,    0

  Plugin_Data_Struct.st_plugin_format_pattern_address=&my_format_pattern;	//         

  Plugin_Data_Struct.st_plugin_submenu_options=1;	//         
  Plugin_Data_Struct.st_plugin_submenu_name_number=50;	//         lng-  1010 (     Plugin_text_strings  1010)
  Plugin_Data_Struct.st_plugin_submenu_struct_number=2;	//     
  Plugin_Data_Struct.st_plugin_submenu_array_address=&Plugin_Submenu_Struct_Array;	//          
  Plugin_Data_Struct.st_plugin_string_proc_address=Plugin_text_strings_address;	//       lng-   
  Plugin_Data_Struct.st_plugin_options_dlg_proc_address=St_Reader_Plugin_Options_address;	//    
  Plugin_Data_Struct.st_plugin_format_proc_address=St_Reader_Plugin_Convertor_Format_address;	//    
  Plugin_Data_Struct.st_plugin_convert_proc_address=St_Reader_Plugin_Convertor_address;	//   

  //Plugin_Data_Struct.st_plugin_reserved1=0
  //Plugin_Data_Struct.st_plugin_reserved2=0
  //Plugin_Data_Struct.st_plugin_reserved3=0
  //Plugin_Data_Struct.st_plugin_reserved4=0
  //Plugin_Data_Struct.st_plugin_reserved5=0

  Plugin_Submenu_Struct_Array[0].st_plugin_submenu_item_name_number=51;	//    1010
  Plugin_Submenu_Struct_Array[0].st_plugin_submenu_item_proc_address=PluginAboutMenuProc_address;
  Plugin_Submenu_Struct_Array[1].st_plugin_submenu_item_name_number=52;	//    1010
  Plugin_Submenu_Struct_Array[1].st_plugin_submenu_item_proc_address=PluginGotoMenuProc_address;

  return &Plugin_Data_Struct;

}

//+++++++++++++++++++++

unsigned int _stdcall St_Reader_Plugin_Convertor(
  unsigned char *read_file_buffer_address,
  unsigned int read_file_length,
  unsigned int *converted_text_buffer_address,
  unsigned int *new_text_length_address,
  unsigned int tab_length,
  HWND prog_hwnd)

{
/*        .       
    GlobalAlloc   =GMEM_FIXED (     
,  )         ANSI ,  
 ( )     ( ,   ),   
    tab_length  .     ,   
    crlf (0D0Ah)        =2

:
  *read_file_buffer_address -  ,     
  read_file_length -     
  *converted_text_buffer_address -    __ ,        
  *new_text_length_address -  ,       ( =0    
  tab_length -      
  prog_hwnd - hwnd          ,  hwnd  

:
   , (=0 -   , =1 -   , =2 -   ) */

int return_code;
unsigned char *memory_block_address;
int position_in_text;   // = 0;
int position_in_new_text = 0;
unsigned int x;
unsigned int *c;
unsigned char *m;
unsigned char *y;
unsigned char *z;
int text_length;
int tab_number = 0;
int new_text_length;

unsigned int _stdcall (*a)(unsigned char *, int);
unsigned int _stdcall (*b)(unsigned char *, int, unsigned char *, unsigned int);



//    INI-   ini_data_structure
  m=0;

//     E  INI-
  lstrcpy((LPTSTR)&ini_data_structure.example_edit_string, (LPCTSTR)&st_plugin_converter_ini_data[m]);
  m=m+lstrlen((LPCTSTR)&st_plugin_converter_ini_data[m])+1;

//     RB  INI-

//  =2      RB  INI=  "1",    =1
  if (lstrcmp((LPCTSTR)&st_plugin_converter_ini_data[m], "1")==0)
    ini_data_structure.example_radiobutton_state=1;
  else
    ini_data_structure.example_radiobutton_state=2;


  m=m+lstrlen((LPCTSTR)&st_plugin_converter_ini_data[m])+1;

//     CHB  INI-
//   CHB  INI=   "ON",     example_combobox_state   BST_UNCHECKED,  BST_CHECKED
  if (lstrcmp((LPCTSTR)&st_plugin_converter_ini_data[m], (LPCTSTR)&checkbox_on_code)==0)
    ini_data_structure.example_checkbox_state=BST_CHECKED;
  else
    ini_data_structure.example_checkbox_state=BST_UNCHECKED;

  m=m+lstrlen((LPCTSTR)&st_plugin_converter_ini_data[m])+1;

//       COMBS  INI-   0, 1  2;    
//"2"   ,    example_combobox_state = 0
  ini_data_structure.example_combobox_state=atol(&st_plugin_converter_ini_data[m]);

  if (ini_data_structure.example_combobox_state>2)
    ini_data_structure.example_combobox_state=0;

// 

  text_length=read_file_length;

//       //mtff//
  if (text_length<8)	// //mtff//
    goto false_format;
  if (strncmp((LPCSTR)read_file_buffer_address, &mttf_tag, 8)==0)
    goto true_format;

false_format:
//           ,      
//          (      )
  return_code=1;
  goto zero_file_length;

true_format:
  if (text_length==8){
    return_code=0;
    goto zero_file_length;
  }

//     
  y=read_file_buffer_address;

//8     //mtff//
  for (position_in_text=8; position_in_text<=text_length; position_in_text++) {

    if (y[position_in_text]=='\x09')	//   = 9
      tab_number++;		//    
  }

//    ,        
//  
  new_text_length=text_length+((tab_length-1)*tab_number);

  memory_block_address=GlobalAlloc(GMEM_FIXED, new_text_length);

  if (memory_block_address==0)
    goto memory_error;

  z=memory_block_address;

// :               
//             =tab_length
  for (position_in_text=8; position_in_text<=text_length; position_in_text++) {

    if (y[position_in_text]=='\0'){
      z[position_in_new_text]=' ';
      position_in_new_text++;
    }
    else if (y[position_in_text]=='\x09') {
      for (x=0; x<tab_length; x++){
        z[position_in_new_text]=' ';
        position_in_new_text++;
      }
    }
    else {
      z[position_in_new_text]=y[position_in_text];
      position_in_new_text++;
    }
  }

  new_text_length=position_in_new_text-1;

//    ANSI.        
//   ANSI     ,   
  if (*Plugin_Data_Struct.st_plugin_code_table_address == 0xFFFFFFFF) {		//0xFFFFFFFF -      

//  
  a=Plugin_Data_Struct.st_plugin_code_determination_proc_address;

//   : memory_block_address= , new_text_length= 
  *Plugin_Data_Struct.st_plugin_code_table_address=(*a)(memory_block_address, new_text_length);
}

/*       ,       
   (  &nbsp; &quot; &#1103;  HTML),  
     .        , 
        ANSI  (  
  ),        ..    .
             ,
            (     
  - UTF-8).       ,       ( 
 GlobalAlloc   GMEM_FIXED)   ,     
converted_text_buffer_address,          . */

/* : memory_block_address=   ( )     
    , new_text_length=  ( ) ,
*Plugin_Data_Struct.st_plugin_code_table_address=   */

  b=Plugin_Data_Struct.st_plugin_text_recoding_proc_address;
  *new_text_length_address=(*b)(memory_block_address, new_text_length, memory_block_address, *Plugin_Data_Struct.st_plugin_code_table_address);

  end_text_position=*new_text_length_address;			//    Plugin_goto_menu_dlg_proc -   
  middle_text_position=*new_text_length_address/2;	//    Plugin_goto_menu_dlg_proc -   

  *converted_text_buffer_address=memory_block_address;
  return 0;

memory_error:
//  
  *new_text_length_address=0;

  return 2;

zero_file_length:
//  
  memory_block_address=GlobalAlloc(GMEM_FIXED, 5);

  if (memory_block_address==0)
    goto memory_error;

  *converted_text_buffer_address=memory_block_address;
  memory_block_address[0]='\x0d';
  memory_block_address[1]='\x0a';
  *new_text_length_address=2;

  return return_code;	//=0  1

}

//+++++++++++++++++++++

unsigned int _stdcall St_Reader_Plugin_Convertor_Format(
  unsigned char *read_file_buffer_address,
  unsigned int read_file_length,
  HWND prog_hwnd)

{

/*   

:
  *read_file_buffer_address -   
  read_file_length -  
  prog_hwnd - hwnd          ,  hwnd  

:
  >0 -       -        = 0xFFFFFFFF -     */

  if (read_file_length<8)
    return 0xFFFFFFFE;
  else {
    if (strncmp((LPCSTR)read_file_buffer_address,&mttf_tag, 8)==0)
      return 0xFFFFFFFE;	//   = 0xFFFFFFFE
    else
      return 0xFFFFFFFF;	//  
  }
}

//+++++++++++++++++++++

unsigned int _stdcall St_Reader_Plugin_Options(
  HWND prog_hwnd)

{

/*  ,     ,     
      ,   INI-  (  )  
           INI-.
  INI-        ( ),     
,      ,          
      -.
      INI- - st_plugin_converter_ini_data -     
St_Reader_Plugin_Convertor      ini_data_structure

:
  prog_hwnd -    ,      DLL

:
  =0-   (    ,     ( )),
  <>0- ,  eax   st_plugin_converter_ini_data,   
      INI-.        ,    
      ( st_plugin_ini_data_string_address  St_Reader_Plugin_Structure)

IDD_OPTIONS_DIALOG_BOX -        
&Plugin_options_dlg_proc -      
&st_plugin_converter_ini_data -   ,   ,   ,
         St_Reader_Plugin_Entry, 
st_plugin_ini_data_string_address  St_Reader_Plugin_Structure (      
INI-    ( ) */

#define IDD_OPTIONS_DIALOG_BOX 510

  return DialogBoxParam(plugin_hInst, MAKEINTRESOURCE(IDD_OPTIONS_DIALOG_BOX), prog_hwnd, &Plugin_options_dlg_proc, st_plugin_converter_ini_data_long);

}

//+++++++++++++++++++++

BOOL APIENTRY _stdcall Plugin_options_dlg_proc(
  HWND hdlg,
  UINT wmsg,
  WPARAM wparam,
  LPARAM lparam)

{

/*    ,         INI- 
    ,   INI-        ,
     (      ,    
) */

#define IDC_EXAMPLE_EDIT_STATIC				1100
#define IDC_EXAMPLE_EDIT						105
#define IDC_EXAMPLE_COMBOBOX_STATIC			1101
#define IDC_EXAMPLE_COMBOBOX			     	106
#define IDC_GROUPBOX_EXAMPLE_RADIOBUTTON	1102
#define IDC_EXAMPLE_RADIOBUTTON1				103
#define IDC_EXAMPLE_RADIOBUTTON2				104
#define IDC_EXAMPLE_CHECKBOX					101


char combobox_string1[] = "String1";
char combobox_string2[] = "String2";
char combobox_string3[] = "String3";

int x, y;
unsigned char *m;
char *z;
char a[10];

//,     ,  ID  (items)     
//   LNG- (-1     )
signed int dlg_language_strings_list[17] = {-1, 1026, IDC_EXAMPLE_EDIT_STATIC, 1020, IDC_EXAMPLE_COMBOBOX_STATIC, 1021, IDC_GROUPBOX_EXAMPLE_RADIOBUTTON, 1022, IDC_EXAMPLE_RADIOBUTTON1, 1023, IDC_EXAMPLE_RADIOBUTTON2, 1024, IDC_EXAMPLE_CHECKBOX, 1025, IDCANCEL, 1027, 0};

  switch(wmsg) {

    case WM_INITDIALOG:

//    INI-   ini_data_structure
  m=0;

//     E  INI-
  lstrcpy((LPTSTR)&ini_data_structure.example_edit_string, (LPCTSTR)&st_plugin_converter_ini_data[m]);
  m=m+lstrlen((LPCTSTR)&st_plugin_converter_ini_data[m])+1;

//     RB  INI-

//  =2      RB  INI=  "1",    =1
  if (lstrcmp((LPCTSTR)&st_plugin_converter_ini_data[m], "1")==0)
    ini_data_structure.example_radiobutton_state=1;
  else
    ini_data_structure.example_radiobutton_state=2;


  m=m+lstrlen((LPCTSTR)&st_plugin_converter_ini_data[m])+1;

//     CHB  INI-
//   CHB  INI=   "ON",     example_combobox_state   BST_UNCHECKED,  BST_CHECKED
  if (lstrcmp((LPCTSTR)&st_plugin_converter_ini_data[m], (LPCTSTR)&checkbox_on_code)==0)
    ini_data_structure.example_checkbox_state=BST_CHECKED;
  else
    ini_data_structure.example_checkbox_state=BST_UNCHECKED;

  m=m+lstrlen((LPCTSTR)&st_plugin_converter_ini_data[m])+1;

//       COMBS  INI-   0, 1  2;    
//"2"   ,    example_combobox_state = 0
  ini_data_structure.example_combobox_state=atol(&st_plugin_converter_ini_data[m]);

  if (ini_data_structure.example_combobox_state>2)
    ini_data_structure.example_combobox_state=0;


//       
      Load_dialog_language(hdlg, &dlg_language_strings_list);

//     IDC_EXAMPLE_EDIT   255
      SendDlgItemMessage(hdlg, IDC_EXAMPLE_EDIT, EM_SETLIMITTEXT, 255, 0);

      ini_data_string_address=(LPTSTR)lparam;

//  IDC_EXAMPLE_EDIT ,   INI- ( )
      SetDlgItemText(hdlg, IDC_EXAMPLE_EDIT, (LPCTSTR)&ini_data_structure.example_edit_string);

// IDC_EXAMPLE_RADIOBUTTON1  IDC_EXAMPLE_RADIOBUTTON2
      if (ini_data_structure.example_radiobutton_state==1)
        y=IDC_EXAMPLE_RADIOBUTTON1;
      else
        y=IDC_EXAMPLE_RADIOBUTTON2;

      CheckDlgButton(hdlg, y, BST_CHECKED);

// IDC_EXAMPLE_CHECKBOX
      CheckDlgButton(hdlg, IDC_EXAMPLE_CHECKBOX, ini_data_structure.example_checkbox_state);

// IDC_EXAMPLE_COMBOBOX
      SendDlgItemMessage(hdlg, IDC_EXAMPLE_COMBOBOX, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)&combobox_string1);
      SendDlgItemMessage(hdlg, IDC_EXAMPLE_COMBOBOX, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)&combobox_string2);
      SendDlgItemMessage(hdlg, IDC_EXAMPLE_COMBOBOX, CB_ADDSTRING, 0, (LPARAM)(LPCSTR)&combobox_string3);

      SendDlgItemMessage(hdlg, IDC_EXAMPLE_COMBOBOX, CB_SETCURSEL, ini_data_structure.example_combobox_state, 0);

      return TRUE;

    case WM_COMMAND:
      switch(wparam) {

        case IDOK:
//   IDC_EXAMPLE_EDIT
          GetDlgItemText(hdlg, IDC_EXAMPLE_EDIT, (LPTSTR)&ini_data_structure.example_edit_string, MAX_PATH);

//  IDC_EXAMPLE_RADIOBUTTON1  IDC_EXAMPLE_RADIOBUTTON2
          if (IsDlgButtonChecked(hdlg, IDC_EXAMPLE_RADIOBUTTON1)==BST_CHECKED)
            ini_data_structure.example_radiobutton_state=1;
          else if (IsDlgButtonChecked(hdlg, IDC_EXAMPLE_RADIOBUTTON2)==BST_CHECKED)
            ini_data_structure.example_radiobutton_state=2;

//  IDC_EXAMPLE_CHECKBOX
          ini_data_structure.example_checkbox_state=IsDlgButtonChecked(hdlg, IDC_EXAMPLE_CHECKBOX);

//  IDC_EXAMPLE_COMBOBOX
          ini_data_structure.example_combobox_state=SendDlgItemMessage(hdlg, IDC_EXAMPLE_COMBOBOX, CB_GETCURSEL, 0, 0);

//   INI-,         
//    E
          lstrcpy((LPTSTR)&st_plugin_converter_ini_data, (LPCTSTR)&ini_data_structure.example_edit_string);

          x=lstrlen((LPCTSTR)&st_plugin_converter_ini_data)+1;

//    RB
          st_plugin_converter_ini_data[x]=ini_data_structure.example_radiobutton_state+0x30;	//0x30 -   
          st_plugin_converter_ini_data[x+1]='\0';

          x=x+2;

//    CHB
          if (ini_data_structure.example_checkbox_state == BST_CHECKED)
            lstrcpy((LPTSTR)&st_plugin_converter_ini_data[x], (LPCTSTR)&checkbox_on_code);
          else
            lstrcpy((LPTSTR)&st_plugin_converter_ini_data[x], (LPCTSTR)&checkbox_off_code);

          x=x+lstrlen((LPCTSTR)&st_plugin_converter_ini_data[x])+1;

//    COMBS
          st_plugin_converter_ini_data[x]=ini_data_structure.example_combobox_state+0x30;	//0x30 -   
          st_plugin_converter_ini_data[x+1]='\0';

          EndDialog(hdlg, (int)ini_data_string_address);

          return TRUE;

        case IDCANCEL:

          EndDialog(hdlg, 0);

          return TRUE;

        default:
          break;
      }

      return FALSE;

    default:
      break;
  }

  return FALSE;
}

//+++++++++++++++++++++

unsigned int _stdcall PluginAboutMenuProc(HWND prog_hwnd)

{

/*      "About My test plugin"     
 My Test

:
  prog_hwnd - hwnd          ,  hwnd   */

#define IDD_ABOUT_DIALOG_BOX 511

  return DialogBoxParam(plugin_hInst, MAKEINTRESOURCE(IDD_ABOUT_DIALOG_BOX), prog_hwnd, &Plugin_about_menu_dlg_proc, 0);

}

//+++++++++++++++++++++

BOOL CALLBACK Plugin_about_menu_dlg_proc(
  HWND hdlg,
  UINT wmsg,
  WPARAM wparam,
  LPARAM lparam)

{
#define IDC_ABOUT_STATIC	1100

//,     ,  ID  (items)     
//   LNG- (-1     )
signed int about_dlg_language_strings_list[5] = {-1, 1061, IDC_ABOUT_STATIC, 1011, 0};

  switch(wmsg) {
    case WM_INITDIALOG:
//       
      Load_dialog_language(hdlg, &about_dlg_language_strings_list);

      return TRUE;

    case WM_COMMAND:
      switch(wparam) {

        case IDOK:case IDCANCEL:
          EndDialog(hdlg, 0);			//=0-     

          return TRUE;

        default:
          break;
      }

    return FALSE;

  default:
    break;
  }

  return FALSE;
}

//+++++++++++++++++++++

unsigned int _stdcall PluginGotoMenuProc(HWND prog_hwnd)

{
/*      "My test goto in text"     
 My Test

:
  prog_hwnd - hwnd          ,  hwnd   */

#define IDD_GOTO_DIALOG_BOX 512

  return DialogBoxParam(plugin_hInst, MAKEINTRESOURCE(IDD_GOTO_DIALOG_BOX), prog_hwnd, &Plugin_goto_menu_dlg_proc, 0);

}

//+++++++++++++++++++++

BOOL CALLBACK Plugin_goto_menu_dlg_proc(
  HWND hdlg,
  UINT wmsg,
  WPARAM wparam,
  LPARAM lparam)

{
#define IDC_GROUPBOX_TEXT_GOTO	1101
#define IDC_GOTO_BEGIN				101
#define IDC_GOTO_MIDDLE				102
#define IDC_GOTO_END					103

//,     ,  ID  (items)     
//   LNG- (-1     )
signed int goto_dlg_language_strings_list[13] = {-1, 1062, IDCANCEL, 1027, IDC_GROUPBOX_TEXT_GOTO, 1063, IDC_GOTO_BEGIN, 1064, IDC_GOTO_MIDDLE, 1065, IDC_GOTO_END, 1066, 0};

//unsigned int begin_text_position = 0;
int x;

  switch(wmsg) {
    case WM_INITDIALOG:
//       
      Load_dialog_language(hdlg, &goto_dlg_language_strings_list);

      CheckDlgButton(hdlg, IDC_GOTO_BEGIN, BST_CHECKED);

      return TRUE;

    case WM_COMMAND:
      switch(wparam) {
        case IDOK:
//       
          x=0;

          if (IsDlgButtonChecked(hdlg, IDC_GOTO_BEGIN)==BST_CHECKED)
            goto radiobutton_checked;	//    

          x=middle_text_position;

          if (IsDlgButtonChecked(hdlg, IDC_GOTO_MIDDLE)==BST_CHECKED)
            goto radiobutton_checked;	//    

          x=end_text_position;

          if (IsDlgButtonChecked(hdlg, IDC_GOTO_END)==BST_CHECKED)
            goto radiobutton_checked;	//    

radiobutton_checked:
          Plugin_Data_Struct.st_plugin_new_reading_text_position=x;

          EndDialog(hdlg, 2);			//=2-        Plugin_Data_Struct.st_plugin_new_reading_text_position
          return TRUE;

        case IDCANCEL:
          EndDialog(hdlg, 0);			//=0-     

          return TRUE;

        default:
          break;
      }

      return FALSE;

    default:
      break;
  }

  return FALSE;
}

//+++++++++++++++++++++

unsigned int _stdcall Plugin_text_strings(
  unsigned int current_language,
  unsigned char *language_file_buffer_address,
  unsigned int string_number,
  unsigned char *string_buffer_address,
  unsigned int string_buffer_size)

{
/*            

:
  current_language: 0-, <>0- 
  *language_file_buffer_address -  -      ,
  string_number=1, 2  3 (1- , 2- , 3-      Open,
  50   -   ),
  *string_buffer_address=    ,
  string_buffer_size=      
:
  =0 -  , <>0 -    (   ) */

unsigned int x;
int result_string_length;

  string_buffer_address[0]='\0';

/*1= "St Reader  -  St"
  2= " -,      - St Reader.\r\nCopyright(c) 2007   . -."
  3= "   My test"    
  50=  " My test"
  51=  "  My test"
  52=  "My test   " */

  switch (string_number) {
    case 1:case 2:case 3:case 50:case 51:case 52:
    break;

    default:
      return 0;
  }

  x=string_number;
  x=x+1010;				//        lng-

  if (current_language!=0)
    goto it_is_not_english_language;

it_is_english_language:
  return LoadString(plugin_hInst, x, string_buffer_address, string_buffer_size);

it_is_not_english_language:
  current_language_file_buffer_address=Open_language_file();

  if (local_language_code==0)	//LNG-        
    goto it_is_english_language;

  if (current_language_file_buffer_address==0)
    return 0;

  result_string_length=Load_language_string(current_language_file_buffer_address, x, (LPCSTR)string_buffer_address, string_buffer_size);

  if (result_string_length==0)
    result_string_length=LoadString(plugin_hInst, x, string_buffer_address, string_buffer_size);

  GlobalFree(current_language_file_buffer_address);

  current_language_file_buffer_address=0;

  return result_string_length;
}

//+++++++++++++++++++++

unsigned int _stdcall Load_language_string(
  unsigned char *language_file_buffer_address,
  unsigned int message_number,
  unsigned char *message_buffer_address,
  unsigned int message_buffer_length)

{
/*       LNG-

:
  *language_file_buffer_address -  -      
  message_number -         
  *message_buffer_address -      
  message_buffer_length -       ,     
:
  =0 -   ,     =   (   ) */


unsigned char number_string_buffer[10];
int number_string_length;
int b;
unsigned int a, y, z;

  message_buffer_address[0]='\0';

  ltoa(message_number, &number_string_buffer, 10);

  number_string_length=lstrlen((LPCTSTR)&number_string_buffer);
  number_string_buffer[number_string_length]='=';

  y=lstrlen(language_file_buffer_address);

  for (z=0; z<=y; z++) {

    if (language_file_buffer_address[z]=='\x0d' && language_file_buffer_address[z+1]=='\x0a'){
      z++;

      if (strncmpi(&language_file_buffer_address[z+1], &number_string_buffer, number_string_length)==0)
        goto string_found;
    }
  }

  if (z==y)
    return 0;

string_found:
  b=0;

  for(a=z+number_string_length+2; a<z+number_string_length+2+message_buffer_length; a++) {

    if (language_file_buffer_address[a]=='\0')
      break;
    if (language_file_buffer_address[a]=='\x0d' && language_file_buffer_address[a+1]=='\x0a')
      break;

//     \r\n     CRLF (13,10  0D0A)
    if (language_file_buffer_address[a]=='\\' && language_file_buffer_address[a+1]=='r' && language_file_buffer_address[a+2]=='\\' && language_file_buffer_address[a+3]=='n') {
      message_buffer_address[b]='\x0d';
      b++;
      message_buffer_address[b]='\x0a';
      b++;
      a=a+4;
    }

    message_buffer_address[b]=language_file_buffer_address[a];
    b++;

  }

  message_buffer_address[b]='\0';

  return lstrlen((LPCSTR)message_buffer_address);		//=   (   )
}

//+++++++++++++++++++++

void _stdcall Load_dialog_language(
  HWND current_hdlg,
  unsigned int *strings_numbers_address)

{
/*       

:
  strings_numbers_address -     :           
     lng-,  2              ( 
      -1); 0     -      */

char message_buffer[1025];
unsigned int x=0;

  if (*Plugin_Data_Struct.st_plugin_language_code_address==0)		//0-  , <>0 -  
    goto open_window_text_eng;

  current_language_file_buffer_address=Open_language_file();		//   LNG-     

//     
  if (local_language_code==0)		// =0  LNG-            -
    goto open_window_text_eng;

//     
  if (Load_language_string(current_language_file_buffer_address, strings_numbers_address[x+1], &message_buffer, 1024)==0)
    goto open_window_text_eng;

  goto set_window_text;

open_window_text_eng:
//    
  LoadString(plugin_hInst, strings_numbers_address[x+1], (LPTSTR)&message_buffer, 1024);

set_window_text:
//   
  SetWindowText(current_hdlg, (LPCTSTR)&message_buffer);

//     
  x=x+2;

loop_set_items_texts:
  if (strings_numbers_address[x]==0)		//      0     strings_numbers_address
    goto exit_loop;

  if (*Plugin_Data_Struct.st_plugin_language_code_address==0)	//0-  , <>0 -  
    goto open_item_text_eng;

  if (local_language_code==0)		// =0  LNG-            -
    goto open_item_text_eng;

  if (Load_language_string(current_language_file_buffer_address, strings_numbers_address[x+1], &message_buffer, 1024)==0)
    goto open_item_text_eng;

  goto set_item_text;

open_item_text_eng:
  LoadString(plugin_hInst, strings_numbers_address[x+1], (LPTSTR)&message_buffer, 1024);

set_item_text:
//     
  SetDlgItemText(current_hdlg, strings_numbers_address[x], (LPCTSTR)&message_buffer);

  x=x+2;
  goto loop_set_items_texts;

exit_loop:
  if (current_language_file_buffer_address==0)
    goto exit_proc;

  GlobalFree(current_language_file_buffer_address);

  current_language_file_buffer_address=0;

exit_proc:
}

//+++++++++++++++++++++

HGLOBAL Open_language_file(void)

{

/*      LNG-     

:
  0-  , <>0-        */

WIN32_FIND_DATA find_data_struct;
char language_template_name[]="\\*.lng";
char plugin_name_in_language_file[] ="St Reader test plugin-converter from St";
LPDWORD lpFileSizeHigh = 0;
char back_slash[] ="\\";
unsigned int read_written_byte_number = 0;
HANDLE find_handle;
HANDLE file_handle;
unsigned int file_size;
unsigned char *memory_address;
int x, y, z, a;

char language_template_buffer[MAX_PATH];
char language_file_buffer[MAX_PATH];
char language_first_strings_buffer[1024];
char current_language_buffer[1024];
char current_language_file_path[MAX_PATH];


  lstrcpy((LPTSTR)&language_template_buffer, (LPCTSTR)Plugin_Data_Struct.st_plugin_program_directory_address);
  lstrcat((LPTSTR)&language_template_buffer, (LPCTSTR)&language_template_name);

// LNG-   
  find_handle=FindFirstFile((LPCTSTR)&language_template_buffer, &find_data_struct);

  if (find_handle==INVALID_HANDLE_VALUE)
    goto set_english_current_language;

  goto next_language_file_found;

loop_count_languages_files:
  if (FindNextFileA(find_handle, &find_data_struct)!=0)
    goto next_language_file_found;
  else {
    FindClose(find_handle);
    goto set_english_current_language;
  }

next_language_file_found:
//LNG- 
//       LNG-
  lstrcpy((LPTSTR)&language_file_buffer, (LPCTSTR)Plugin_Data_Struct.st_plugin_program_directory_address);
  lstrcat((LPTSTR)&language_file_buffer, (LPCTSTR)&back_slash);
  lstrcat((LPTSTR)&language_file_buffer, find_data_struct.cFileName);

  file_handle=CreateFile((LPCTSTR)&language_file_buffer, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

//  1024   LNG-      
  ReadFile(file_handle, (LPVOID)&language_first_strings_buffer, 1024, (LPDWORD)&read_written_byte_number, 0);

  file_size=GetFileSize(file_handle, (LPDWORD)&lpFileSizeHigh);

  CloseHandle(file_handle);

  if (file_size<1024)
    x=file_size;
  else
    x=1024;

  for (y=0; y<=x; y++) {
    if (language_first_strings_buffer[y]=='\x0d' && language_first_strings_buffer[y+1]=='\x0a'){
      language_first_strings_buffer[y]='\0';
      break;
    }
  }

  if (y==x)
    goto loop_count_languages_files;

  if (lstrcmp((LPCTSTR)&plugin_name_in_language_file, (LPCTSTR)&language_first_strings_buffer[0])!=0)
    goto loop_count_languages_files;

  y=y+2;

  for (z=y; z<=x; z++) {
    if (language_first_strings_buffer[z]=='\x0d' && language_first_strings_buffer[z+1]=='\x0a'){
      language_first_strings_buffer[z]='\0';
      break;
    }
  }

  if (z==x)
    goto loop_count_languages_files;

  if (lstrcmpi(Plugin_Data_Struct.st_plugin_language_name_address, (LPCTSTR)&language_first_strings_buffer[y])!=0)	//=0       LNG-      (  )
    goto loop_count_languages_files;

  lstrcpy((LPTSTR)&current_language_file_path, (LPCSTR)Plugin_Data_Struct.st_plugin_program_directory_address);
  lstrcat((LPTSTR)&current_language_file_path, (LPCTSTR)&back_slash);
  lstrcat((LPTSTR)&current_language_file_path, find_data_struct.cFileName);

// LNG-         
  file_handle=CreateFile((LPCSTR)&current_language_file_path, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

  file_size=GetFileSize(file_handle, (LPDWORD)&lpFileSizeHigh);
  file_size++;

  memory_address=GlobalAlloc(GMEM_FIXED, file_size);

  ReadFile(file_handle, (LPVOID)memory_address, file_size, (LPDWORD)&read_written_byte_number, 0);

  a=file_size-1;
  memory_address[a]='\0';

  CloseHandle(file_handle);

  local_language_code=1;	//LNG-          

  return memory_address;

set_english_current_language:
  local_language_code=0;

  return 0;
}
