//

unsigned int _stdcall St_Reader_Plugin_Convertor(unsigned char *, unsigned int, unsigned int *, unsigned int *, unsigned int, HWND);
unsigned int _stdcall St_Reader_Plugin_Convertor_Format(unsigned char *, unsigned int, HWND);
unsigned int _stdcall St_Reader_Plugin_Options(HWND);
unsigned int _stdcall PluginAboutMenuProc(HWND);
unsigned int _stdcall PluginGotoMenuProc(HWND);
BOOL CALLBACK Plugin_options_dlg_proc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK Plugin_goto_menu_dlg_proc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK Plugin_about_menu_dlg_proc(HWND, UINT, WPARAM, LPARAM);
unsigned int _stdcall Plugin_text_strings(unsigned int, unsigned char *, unsigned int, unsigned char *, unsigned int);
unsigned int _stdcall Load_language_string(unsigned char *, unsigned int, unsigned char *, unsigned int);
void _stdcall Load_dialog_language(HWND, unsigned int *);	//strings_numbers_address[]
HGLOBAL Open_language_file(void);


struct St_Reader_Plugin_Structure {
	unsigned int st_plugin_size;				//  
	unsigned char *st_plugin_string;			//    "St Reader converter"
	unsigned int st_plugin_ver;				//     (   = 10    19,   20     )
	unsigned int st_plugin_program_ver;			//     (   = 10) -  St Reader'
	unsigned int st_plugin_options;			//    : 0-, 1-?
	unsigned char *st_plugin_ini_data_string_address;	//        ini , 0-   ( )
	unsigned char *st_plugin_ini_data_address;		//            ini  (         ), 0-   ( )
	unsigned int st_plugin_format_number;		//     ,    ini-        (   )
	unsigned int st_plugin_converter_veracity;	//    (  ,      ,      )  5- : 1- ,    , 5- , 0-  TXT-
	unsigned int st_plugin_converter_unicode_flag;	//0=ANSI (1 byte), 1=unicode (2 bytes))
	unsigned int st_plugin_converter_font_code;	//      : -1-    ,  . lfCharSet   LOGFONT
	unsigned int st_plugin_converter_right_to_left_flag;	//0-   ( ), 1-  
	unsigned char *st_plugin_format_pattern_address;	//  pattern ( "*.htm;*.html")     (     )
	unsigned int st_plugin_submenu_options;		//         : 0-, 1-?
	unsigned int st_plugin_submenu_name_number;	//     Plugin_text_strings           , 0-  
	unsigned int st_plugin_submenu_struct_number;	//  St_Plugin_Submenu_Structure, 0-  
	struct St_Plugin_Submenu_Structure *st_plugin_submenu_array_address;	//   St_Plugin_Submenu_Structure    , 0-  
	unsigned int st_plugin_new_reading_text_position;	//   ( ,        ),           ,    (. st_plugin_submenu_array_address)
	unsigned int *st_plugin_string_proc_address;	//       (  =1- , =2- , =3-      Open,  )
	unsigned int *st_plugin_options_dlg_proc_address;	//     , 0-  
	unsigned int *st_plugin_format_proc_address;	//    
	unsigned int *st_plugin_convert_proc_address;	//   
	unsigned int st_plugin_program_flags;		//      St Reader ( ) -  St Reader'
	unsigned char *st_plugin_program_directory_address;	//  ( \) -  St Reader'
	unsigned char *st_plugin_open_file_path_address;	//      -  St Reader'
	unsigned int *st_plugin_language_code_address;	// ,    (0-, <>0-) -  St Reader'
	unsigned char *st_plugin_language_name_address;	// ,    -  St Reader'
	unsigned long *st_plugin_code_table_address;	//    -  St Reader'
	unsigned int *st_plugin_code_determination_proc_address;	//     (:   ,   ) -  St Reader'
	unsigned int *st_plugin_text_recoding_proc_address;	//   ,    -  St Reader'
	struct LOGFONT *st_plugin_text_font_address;	// c LOGFONT     -  St Reader'
	unsigned int st_plugin_text_font_color_address;	//     -  St Reader'
	unsigned int st_plugin_text_background_color_address;	//     -  St Reader'
	unsigned int st_plugin_reserved1;			//,  
	unsigned int st_plugin_reserved2;			//,  
	unsigned int st_plugin_reserved3;			//,  
	unsigned int st_plugin_reserved4;			//,  
	unsigned int st_plugin_reserved5;			//,  
};

#define St_Reader_Plugin_Structure_size sizeof(St_Reader_Plugin_Structure)

//st_plugin_ini_data_string_address -   ini       ,   
// .
//
// st_plugin_ini_data_address       ini-  , 
// ,       ini  st_plugin_ini_data_string_address
// st_plugin_ini_data_string_address=0   st_plugin_ini_data_address=0
//        ( )
//        st_plugin_ini_data_address    ,
//     ini- (        options,     
// (     ..)).     ini-    
//  options  ,        ,    
// .
//
//st_plugin_text_recoding_proc_address -     (:    
//(   1 ),   ,   (1  ),    
// (    ,      ),   .
//       (       ( 
// )    (  )),  0  .
//
//st_plugin_program_flags -        St Reader:
//_READER_MAIN_ABILITIES = 0		//     (      !)
//_READER_UNICODE = 1	 	//    Unicode ( st_plugin_converter_unicode_flag)
//_READER_CHARSET = 2		//       ( st_plugin_converter_font_code)
//_READER_RIGHT_TO_LEFT = 4	//     ( st_plugin_converter_right_to_left_flag)
//
//
//*******************************************************************
//
struct St_Plugin_Submenu_Structure {
	unsigned int st_plugin_submenu_item_name_number;	//     Plugin_text_strings          
	unsigned int st_plugin_submenu_item_proc_address;	//  ,         ( :0-  , -1-   , 2-        st_plugin_text_position_address)
};

#define St_Plugin_Submenu_Structure_size sizeof(St_Plugin_Submenu_Structure)

//*******************************************************************
//    (        St Reader  
//   )
//
// = 0xFFFFFFFF)
//St Reader test plugin-converter from St = 0xFFFFFFFE
//
//TXT = 0	-    
//St Reader HTML plugin from St = 1
//St Reader RTF plugin from St = 2
//St Reader FictionBook 2.0 (FB2) plugin from St = 3
//Microsoft Word DOC = 4	;!!!
//
//
//
//*******************************************************************

//*******************************************************************
//
//   
//
// = 0xFFFFFFFF
//0=WIN
//1=DOS
//2=KOI8R
//3=UTF-8
//
//
//
//*******************************************************************